package org.wfc.omada.api.sitesetting.model;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModelProperty;

import javax.validation.Valid;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * TimeRangeProfileOpenApiVo
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.SpringCodegen", date = "2024-12-04T11:32:19.054+08:00[Asia/Shanghai]")

public class TimeRangeProfileOpenApiVo   {
  @JsonProperty("profileId")
  private String profileId;

  @JsonProperty("name")
  private String name;

  @JsonProperty("dayMode")
  private Integer dayMode;

  @JsonProperty("customDayMode")
  private CustomDayModeOpenApiVo customDayMode;

  @JsonProperty("timeList")
  @Valid
  private List<ScheduleTimeOpenApiVo> timeList = null;

  public TimeRangeProfileOpenApiVo profileId(String profileId) {
    this.profileId = profileId;
    return this;
  }

  /**
   * Time range profile ID
   * @return profileId
  */
  @ApiModelProperty(value = "Time range profile ID")


  public String getProfileId() {
    return profileId;
  }

  public void setProfileId(String profileId) {
    this.profileId = profileId;
  }

  public TimeRangeProfileOpenApiVo name(String name) {
    this.name = name;
    return this;
  }

  /**
   * Time range profile name should contain 1 to 64 characters.
   * @return name
  */
  @ApiModelProperty(value = "Time range profile name should contain 1 to 64 characters.")


  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public TimeRangeProfileOpenApiVo dayMode(Integer dayMode) {
    this.dayMode = dayMode;
    return this;
  }

  /**
   * Time range profile day mode; It should be a value as follows: 0: Every Day, 1: Weekday, 2: Weekend, 3: Customized
   * @return dayMode
  */
  @ApiModelProperty(value = "Time range profile day mode; It should be a value as follows: 0: Every Day, 1: Weekday, 2: Weekend, 3: Customized")


  public Integer getDayMode() {
    return dayMode;
  }

  public void setDayMode(Integer dayMode) {
    this.dayMode = dayMode;
  }

  public TimeRangeProfileOpenApiVo customDayMode(CustomDayModeOpenApiVo customDayMode) {
    this.customDayMode = customDayMode;
    return this;
  }

  /**
   * Get customDayMode
   * @return customDayMode
  */
  @ApiModelProperty(value = "")

  @Valid

  public CustomDayModeOpenApiVo getCustomDayMode() {
    return customDayMode;
  }

  public void setCustomDayMode(CustomDayModeOpenApiVo customDayMode) {
    this.customDayMode = customDayMode;
  }

  public TimeRangeProfileOpenApiVo timeList(List<ScheduleTimeOpenApiVo> timeList) {
    this.timeList = timeList;
    return this;
  }

  public TimeRangeProfileOpenApiVo addTimeListItem(ScheduleTimeOpenApiVo timeListItem) {
    if (this.timeList == null) {
      this.timeList = new ArrayList<>();
    }
    this.timeList.add(timeListItem);
    return this;
  }

  /**
   * Time range profile schedule time config
   * @return timeList
  */
  @ApiModelProperty(value = "Time range profile schedule time config")

  @Valid

  public List<ScheduleTimeOpenApiVo> getTimeList() {
    return timeList;
  }

  public void setTimeList(List<ScheduleTimeOpenApiVo> timeList) {
    this.timeList = timeList;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    TimeRangeProfileOpenApiVo timeRangeProfileOpenApiVo = (TimeRangeProfileOpenApiVo) o;
    return Objects.equals(this.profileId, timeRangeProfileOpenApiVo.profileId) &&
        Objects.equals(this.name, timeRangeProfileOpenApiVo.name) &&
        Objects.equals(this.dayMode, timeRangeProfileOpenApiVo.dayMode) &&
        Objects.equals(this.customDayMode, timeRangeProfileOpenApiVo.customDayMode) &&
        Objects.equals(this.timeList, timeRangeProfileOpenApiVo.timeList);
  }

  @Override
  public int hashCode() {
    return Objects.hash(profileId, name, dayMode, customDayMode, timeList);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class TimeRangeProfileOpenApiVo {\n");
    
    sb.append("    profileId: ").append(toIndentedString(profileId)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    dayMode: ").append(toIndentedString(dayMode)).append("\n");
    sb.append("    customDayMode: ").append(toIndentedString(customDayMode)).append("\n");
    sb.append("    timeList: ").append(toIndentedString(timeList)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

